;; http://abcdugimp.free.fr
;; ---------------------------------------------------------
;; *									     				
;; * 		      Script-Fu Luminescence +    	
;; *							   		     				
;; ---------------------------------------------------------
;; creative commons licence
;; http://creativecommons.org/licenses/by-nc-sa/2.0/fr/




;; ---------------------------------------------------------
;; *	 	Affiche les images d'un Script-Fu  		     *
;; ---------------------------------------------------------

(define (script-fu-affiche-images-luminescence    script 
															taille-x taille-y turb detail
															mode1 mode2
															couleur)

(let* (
	;; taille de l'image
	(image-width 256)
	(image-height 256)
	
	(mode1 (+ mode1 2))
	(mode2 (+ mode2 2))

	;; creation de l'image
	(image (car (gimp-image-new image-width image-height RGB)))

	;; init
	(inc 0)
	(deux 0)
	(un 0)
	(liste 0)
	(m1 0)
	(m2 0)
	(nom 0)
	)

(if (= script 0)
	(begin
		(while (< inc 16)
			(apply-luminescence-volute
					image
					image-width image-height
					inc 
					taille-x taille-y turb detail
					FALSE)
			( set! inc (+ inc 1))
		)
	)		
)

(if (= mode1 2) (set! mode1 6))
(if (= mode2 2) (set! mode2 7))

(set! liste (cadr (gimp-gradients-get-list "")))

(if (= script 1)
	(begin
		(while (not (null? liste))
			(set! nom (car liste))
			;;(gimp-message nom)
			(apply-luminescence-volute-abstract
					image
					image-width image-height
					mode1 nom
					mode2 taille-x taille-y turb detail
					FALSE)
			(set! liste (cdr liste))
		)
	)		
)

(if (= script 2)
	(begin
		(while (< deux 4)
			(set! un 0)
			(while (< un 3)
				(if (= deux 0) (set! m2 "DIFFERENCE"))
				(if (= deux 1) (set! m2 "SOUSTRACTION"))
				(if (= deux 2) (set! m2 "EXTRACTION de GRAIN"))
				(if (= deux 3) (set! m2 "DIVISER"))

				(if (= un 0) (set! m1 "DIFFERENCE"))
				(if (= un 1) (set! m1 "SOUSTRACTION"))
				(if (= un 2) (set! m1 "EXTRACTION de GRAIN"))

				(set! nom (string-append m2 " + " m1))
				
				(apply-luminescence-entrelats
						image
						nom
						FALSE
						couleur
						image-width image-height
						taille-x taille-y turb detail
						deux un
						FALSE)
				(set! un (+ un 1))
			)
		(set! deux (+ deux 1))
		)

		(apply-luminescence-entrelats
						image
						"Repoussage"
						TRUE
						couleur
						image-width image-height
						taille-x taille-y turb detail
						0 0
						FALSE)
	)		
)


;; mise a jour
	(gimp-display-new image)

   )
)

;; registre 
(script-fu-register "script-fu-affiche-images-luminescence"
		    "Affiche de nombreuses images possibles"
		    "Affiche de nombreuses images possible du script-fu selectionné."
			"Michel Douez"
			"abcdugimp.free.fr - creative commons licence"
		    "31/10/2007"
		    ""
	SF-OPTION "Script" '("Volute" "Volute abstraite" "Entrelacs")
	SF-ADJUSTMENT "Taille X" '(5 0.1 16 0.1 1 1 0)
	SF-ADJUSTMENT "Taille Y" '(5 0.1 16 0.1 1 1 0)
	SF-TOGGLE "Turbulent ?" TRUE
	SF-ADJUSTMENT "Detail" '(1 1 15 1 4 0 1)
	SF-OPTION "Mode de calque du dégradé
		     UNIQUEMENT POUR VOLUTE ABSTRAITE" '("2 - Défaut (différence)" "3 - Multiplier" "4 - Ecran" "5 - Superposer" "6 - Différence" "7 - Addition" "8 - Soustraction" "9 - Noircir seulement" "10 - Eclaircir seulement" "11 - Teinte" "12 - Saturation" "13 - Couleur" "14 - Valeur" "15 - Diviser" "16 - Eclaircir" "17 - Assombrir" "18 - Lumière dure" "19 - Lumière douce" "20 - Extraction de grain" "21 - Fusion de grain" "22 - Erase color")
	SF-OPTION "Mode de calque psychadélique
		     UNIQUEMENT POUR VOLUTE ABSTRAITE" '("2 - Défaut (addition)" "3 - Multiplier" "4 - Ecran" "5 - Superposer" "6 - Différence" "7 - Addition" "8 - Soustraction" "9 - Noircir seulement" "10 - Eclaircir seulement" "11 - Teinte" "12 - Saturation" "13 - Couleur" "14 - Valeur" "15 - Diviser" "16 - Eclaircir" "17 - Assombrir" "18 - Lumière dure" "19 - Lumière douce" "20 - Extraction de grain" "21 - Fusion de grain" "22 - Erase color")
	SF-COLOR "Couleur - UNIQUEMENT POUR ENTRELACS" '(33 100 58)
)

(script-fu-menu-register "script-fu-affiche-images-luminescence" "<Image>/Filters/abcdugimp.free.fr/Motifs/Luminescence + 2.1/")
;; ---------------------------------------------------------
;; *	 	Affiche les images d'un Script-Fu  		     
;; ----END--------------------------------------------------




;; ---------------------------------------------------------
;; *									    
;; * 		         Script-Fu reflet 
;; *							   		     
;; ---------------------------------------------------------

(define (script-fu-luminescence-reflet  	image-width image-height
													lum-blanche
													coin1 color1 coin2 color2 coin3 color3 coin4 color4
													taille-x taille-y turb detail mode
													conserv)


;; init generale
    (let* (
		(flare2-layer 0)
		(flare3-layer 0)
		(flare4-layer 0)
		
		;; conserver les outils dans des variables
		(old-fg (car (gimp-context-get-foreground)))
		(old-deg (car (gimp-context-get-gradient)))
		
		;; creation de l'image
		(image (car (gimp-image-new image-width image-height RGB)))

		;; creation des calques
		(fond-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Arrière-plan" 100 NORMAL))) ;; fond noir
		(flare1-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Dégradé 1" 100 NORMAL))) ;;
		(uni-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Brouillage uni" 100 NORMAL))) ;;

		;; decalage pour le remplissage du degrade
		(decalage-x (/ image-width 6))
		(decalage-y (/ image-height 6))
	   )

	;; add layer
	(gimp-image-add-layer image fond-layer -1)
	(gimp-image-add-layer image flare1-layer -1)
	
	

;; initialisations
(gimp-context-set-foreground '(0 0 0))
(gimp-context-set-gradient "Flare Radial 102")
	
;; init calques ;; vider les calques pour qu'il n'y est pas de trace indesirable
(gimp-edit-clear flare1-layer)
	


;; --------------------------------------------------
;;			base
;; --------------------------------------------------

(gimp-edit-fill fond-layer 0) ;; remplir le fond de noir

;; --------------------------------------------------

;; degrade suivant lum-blanche
(if (= lum-blanche 1)
	(begin ;; beaucoup de lumiere blanche
		(gimp-edit-blend flare1-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE image-width 0 (- decalage-x) (+ image-height decalage-y))
	)
	(begin ;; peu de lumiere blanche
		(gimp-edit-blend flare1-layer 3 0 0 100 0 0 FALSE FALSE 0 0 TRUE (+ image-width decalage-x) (- decalage-y) (- decalage-x) (+ image-height decalage-y))
	)
)
;; dupliquer les 3 autres calques de degrade
(set! flare2-layer (car (gimp-layer-new-from-drawable flare1-layer image)))
(gimp-image-add-layer image flare2-layer -1)
(gimp-drawable-set-name flare2-layer "Dégradé 2")
(gimp-drawable-transform-flip-simple flare2-layer ORIENTATION-VERTICAL TRUE 0 TRUE)

(set! flare3-layer (car (gimp-layer-new-from-drawable flare2-layer image)))
(gimp-image-add-layer image flare3-layer -1)
(gimp-drawable-set-name flare3-layer "Dégradé 3")
(gimp-drawable-transform-flip-simple flare3-layer ORIENTATION-HORIZONTAL TRUE 0 TRUE)

(set! flare4-layer (car (gimp-layer-new-from-drawable flare3-layer image)))
(gimp-image-add-layer image flare4-layer -1)
(gimp-drawable-set-name flare4-layer "Dégradé 4")
(gimp-drawable-transform-flip-simple flare4-layer ORIENTATION-VERTICAL TRUE 0 TRUE)

;; regler le mode et les calques qui seront affichés
(if (= color1 1)
(gimp-layer-set-mode flare1-layer GRAIN-EXTRACT-MODE)
)
(if (= coin1 FALSE)
(gimp-image-remove-layer image flare1-layer)
)
(if (= color2 1)
(gimp-layer-set-mode flare2-layer GRAIN-EXTRACT-MODE)
)
(if (= coin2 FALSE)
(gimp-image-remove-layer image flare2-layer)
)
(if (= color3 0)
(gimp-layer-set-mode flare3-layer GRAIN-EXTRACT-MODE)
)
(if (= coin3 FALSE)
(gimp-image-remove-layer image flare3-layer)
)
(if (= color4 1)
(gimp-layer-set-mode flare4-layer GRAIN-EXTRACT-MODE)
)
(if (= coin4 FALSE)
(gimp-image-remove-layer image flare4-layer)
)

;; --------------------------------------------------

(gimp-image-add-layer image uni-layer -1)
(gimp-edit-clear uni-layer)
(plug-in-solid-noise RUN-NONINTERACTIVE image uni-layer 0 turb 0 detail taille-x taille-y)
(if (= mode 0)
(gimp-layer-set-mode uni-layer DIVIDE-MODE)
)
(if (= mode 1)
(gimp-layer-set-mode uni-layer GRAIN-EXTRACT-MODE)
)
(if (= mode 2)
(gimp-layer-set-mode uni-layer SUBTRACT-MODE)
)

;; --------------------------------------------------

(if (= conserv FALSE)
(gimp-image-flatten image)
)

;; mise a jour
	(gimp-display-new image)

	
	;; remettre toutes les outils comme au debut
	(gimp-context-set-foreground old-fg)
	(gimp-context-set-gradient old-deg)

  )
)


;; registre 
(script-fu-register "script-fu-luminescence-reflet"
		    "Reflet"
		    "Génère une texture, effet de lumière : reflet d'eau."
		    "Michel Douez"
			"abcdugimp.free.fr - creative commons licence"
		    "31/10/2007"
		    ""
	SF-ADJUSTMENT _"Width" '(512 10 1024 1 100 0 0)
	SF-ADJUSTMENT _"Height" '(384 10 768 1 100 0 0)
	SF-OPTION "Lumière blanche dans les coins" '("Peu" "Beaucoup")
	SF-TOGGLE "Coin supérieur droit ?" FALSE
	SF-OPTION "Couleur du reflet" '("Rouge" "Bleu")
	SF-TOGGLE "Coin inférieur droit ?" FALSE
	SF-OPTION "Couleur du reflet" '("Rouge" "Bleu")
	SF-TOGGLE "Coin inférieur gauche ?" TRUE
	SF-OPTION "Couleur du reflet" '("Bleu" "Rouge")
	SF-TOGGLE "Coin supérieur gauche ?" TRUE
	SF-OPTION "Couleur du reflet" '("Rouge" "Bleu")
	SF-ADJUSTMENT "Taille X" '(16 0.1 16 0.1 1 1 0)
	SF-ADJUSTMENT "Taille Y" '(4 0.1 16 0.1 1 1 0)
	SF-TOGGLE "Turbulent ?" TRUE
	SF-ADJUSTMENT "Détail" '(1 1 15 1 4 0 1)
	SF-OPTION "Mode de calque du brouillage" '("Diviser" "Extraction" "Soustraction")
	SF-TOGGLE "Conserver les calques ?" FALSE
)

(script-fu-menu-register "script-fu-luminescence-reflet" "<Image>/Filters/abcdugimp.free.fr/Motifs/Luminescence + 2.1/")
;; ---------------------------------------------------------
;; * 		         Script-Fu reflet 
;; ----END--------------------------------------------------




;; ---------------------------------------------------------
;; *									    
;; * 		         Script-Fu volute 
;; *							   		     
;; ---------------------------------------------------------

(define (apply-luminescence-volute 	image
												image-width image-height
												type 
												taille-x taille-y turb detail
												conserv)


;; init generale
    (let* (
	;; creation des calques
	(uni-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Brouillage uni" 100 NORMAL))) ;; 
	(deg-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Dégradé" 100 NORMAL))) ;;
	)

	;; add layer
	(gimp-image-add-layer image uni-layer -1)
	(gimp-image-add-layer image deg-layer -1)
	
	

;; init calques ;; vider les calques pour qu'il n'y est pas de trace indesirable
(gimp-edit-clear deg-layer)
	


;; --------------------------------------------------
;;			base
;; --------------------------------------------------

;; regler le degrade en cours et le mode de calque suivant l'option "type"
;; <-------------- degrade
(if (= type 0)
	(begin
		(gimp-context-set-gradient "Golden")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 1)
	(begin
		(gimp-context-set-gradient "Horizon 2")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 2)
	(begin
		(gimp-context-set-gradient "Incandescent")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 3)
	(begin
		(gimp-context-set-gradient "Incandescent")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer HARDLIGHT-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 4)
	(begin
		(gimp-context-set-gradient "Metallic Something")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 5)
	(begin
		(gimp-context-set-gradient "Deep Sea")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 6)
	(begin
		(gimp-context-set-gradient "Crown molding")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 (/ image-height 4) 0 (* (/ image-height 4) 3))
	)
)
(if (= type 7)
	(begin
		(gimp-context-set-gradient "Browns")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 8)
	(begin
		(gimp-context-set-gradient "Wood 1")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 9)
	(begin
		(gimp-context-set-gradient "Yellow Orange")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)
	)
)
(if (= type 10)
	(begin
		(gimp-context-set-gradient "Three bars sin")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 4 100 0 0 FALSE FALSE 0 0 FALSE (/ image-width 2) (/ image-height 2) 0 image-height) ;; symetrique
	)
)
(if (= type 11)
	(begin
		(gimp-context-set-gradient "Three bars sin")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-edit-blend deg-layer 3 0 5 100 0 0 FALSE FALSE 0 0 FALSE (/ image-width 2) (/ image-height 2) 0 image-height) ;; assymetrique
	)
)
;; ------------->

;; <--------------- pattern
(if (= type 12)
	(begin
		(gimp-context-set-pattern "Burlwood")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-pattern)))
		(gimp-layer-set-mode deg-layer GRAIN-EXTRACT-MODE)
	(gimp-drawable-fill deg-layer 4)
	)
)
(if (= type 13)
	(begin
		(gimp-context-set-pattern "Burlwood")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-pattern)))
		(gimp-layer-set-mode deg-layer DODGE-MODE)
	(gimp-drawable-fill deg-layer 4)
	)
)
(if (= type 14)
	(begin
		(gimp-context-set-pattern "Craters")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-pattern)))
		(gimp-layer-set-mode deg-layer GRAIN-EXTRACT-MODE)
	(gimp-drawable-fill deg-layer 4)
	)
)
(if (= type 15)
	(begin
		(gimp-context-set-pattern "Ice")
		(gimp-drawable-set-name deg-layer (car (gimp-context-get-pattern)))
		(gimp-layer-set-mode deg-layer DIFFERENCE-MODE)
	(gimp-drawable-fill deg-layer 4)
	)
)
;; ----------->

;; --------------------------------------------------

(if (= conserv FALSE)
	(gimp-drawable-set-name uni-layer (string-append "Volute numéro " (number->string type)))
)
(plug-in-solid-noise RUN-NONINTERACTIVE image uni-layer 0 turb 0 detail taille-x taille-y)

;; --------------------------------------------------


(if (= conserv FALSE)
	(gimp-image-merge-down image deg-layer EXPAND-AS-NECESSARY)
)

   )
)



(define (script-fu-luminescence-volute 	image-width image-height
													type 
													taille-x taille-y turb detail
													conserv)

(let* (
	;; conserver les outils dans des variables
	(old-deg (car (gimp-context-get-gradient)))
	(old-pat (car (gimp-context-get-pattern)))

	;; creation de l'image
	(image (car (gimp-image-new image-width image-height RGB)))
	)

	(apply-luminescence-volute 	image
											image-width image-height
											type 
											taille-x taille-y turb detail
											conserv)


;; mise a jour
	(gimp-display-new image)
	;; remettre toutes les outils comme au debut
	(gimp-context-set-gradient old-deg)
	(gimp-context-set-pattern old-pat)

   )
)

;; registre 
(script-fu-register "script-fu-luminescence-volute"
		    "Volute"
		    "Génère une texture, effet de lumière : volute."
		    "Michel Douez"
			"abcdugimp.free.fr - creative commons licence"
		    "31/10/2007"
		    ""
	SF-ADJUSTMENT _"Width" '(256 10 1024 1 100 0 0)
	SF-ADJUSTMENT _"Height" '(256 10 768 1 100 0 0)
	SF-OPTION "Type" '("0 - Or" "1 - Bleu symétrique" "2 - Feu et fumée" "3 - Feu" "4 - Froid" "5 - Flamme bleue" "6 - Barre" "7 - Flamme brune" "8 - Orange" "9 - Orange vif" "10 - Etoile 8" "11 - Etoile 3" "12 - Océan" "13 - Volcan" "14 - Pierre" "15 - Eau")
	SF-ADJUSTMENT "Taille X" '(5 0.1 16 0.1 1 1 0)
	SF-ADJUSTMENT "Taille Y" '(5 0.1 16 0.1 1 1 0)
	SF-TOGGLE "Turbulent ?" TRUE
	SF-ADJUSTMENT "Détail" '(1 1 15 1 4 0 1)
	SF-TOGGLE "Conserver les calques ?" FALSE
)

(script-fu-menu-register "script-fu-luminescence-volute" "<Image>/Filters/abcdugimp.free.fr/Motifs/Luminescence + 2.1/")
;; ---------------------------------------------------------
;; * 		         Script-Fu volute 
;; ----END--------------------------------------------------




;; ---------------------------------------------------------
;; *									     
;; * 		    Script-Fu volute abstraite 
;; *							   		     
;; ---------------------------------------------------------

(define (apply-luminescence-volute-abstract 	image
														image-width image-height
														mode1 degrade 
														mode2 taille-x taille-y turb detail
														conserv)


;; init generale
    (let* (
		(uni2-layer 0)
		
		;; creation des calques
		(uni-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Brouillage uni" 100 NORMAL))) ;; 
		(deg-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Dégradé" 100 NORMAL))) ;;
	)

	;; add layer
	(gimp-image-add-layer image uni-layer -1)
	

;; --------------------------------------------------
;;			base
;; --------------------------------------------------

;; --------------------------------------------------

(plug-in-solid-noise RUN-NONINTERACTIVE image uni-layer 0 turb 0 detail taille-x taille-y)

(set! uni2-layer (car (gimp-layer-new-from-drawable uni-layer image))) ;; dupliquer
(gimp-image-add-layer image uni2-layer -1)
(gimp-drawable-set-name uni2-layer "Brouillage uni psychadélique")
(gimp-layer-set-mode uni2-layer mode2)
;; (plug-in-alienmap 1 image uni2-layer 128 80 0 0 2 2)
(plug-in-alienmap2 RUN-NONINTERACTIVE image uni2-layer 1 0 1 0 1 0 0 TRUE FALSE FALSE) ;; psychadelique

(if (= conserv FALSE)
	(gimp-drawable-set-name uni-layer (string-append "Volute abstraite " degrade))
)

;; --------------------------------------------------

;; regler le degrade en cours et le mode de calque
	(gimp-image-add-layer image deg-layer -1)
	(gimp-edit-clear deg-layer) ;; vider les calques pour qu'il n'y est pas de trace indesirable
	(gimp-context-set-gradient degrade)
	(gimp-drawable-set-name deg-layer (car (gimp-context-get-gradient)))
	(gimp-layer-set-mode deg-layer mode1)
	(gimp-edit-blend deg-layer 3 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 0 0 image-height)


(if (= conserv FALSE)
	(begin
		(gimp-image-merge-down image uni2-layer EXPAND-AS-NECESSARY)
		(gimp-image-merge-down image deg-layer EXPAND-AS-NECESSARY)
	)
)

   )
)



(define (script-fu-luminescence-volute-abstract image-width image-height
												degrade 
												taille-x taille-y turb detail
												conserv)

(let* (
	;; conserver les outils dans des variables
	(old-deg (car (gimp-context-get-gradient)))

	;; creation de l'image
	(image (car (gimp-image-new image-width image-height RGB)))
	)
	
	(apply-luminescence-volute-abstract 	image
													image-width image-height
													DIFFERENCE-MODE degrade
													ADDITION-MODE taille-x taille-y turb detail
													conserv)


;; mise a jour
	(gimp-display-new image)
	;; remettre toutes les outils comme au debut
	(gimp-context-set-gradient old-deg)

   )
)

;; registre 
(script-fu-register "script-fu-luminescence-volute-abstract"
		    "Volute abstraite"
		    "Génère une texture, effet de lumière : volute abstraite."
		    "Michel Douez"
			"abcdugimp.free.fr - creative commons licence"
		    "31/10/2007"
		    ""
	SF-ADJUSTMENT _"Width" '(256 10 1024 1 100 0 0)
	SF-ADJUSTMENT _"Height" '(256 10 768 1 100 0 0)
	SF-GRADIENT "Dégradé" "Golden"
	SF-ADJUSTMENT "Taille X" '(5 0.1 16 0.1 1 1 0)
	SF-ADJUSTMENT "Taille Y" '(5 0.1 16 0.1 1 1 0)
	SF-TOGGLE "Turbulent ?" TRUE
	SF-ADJUSTMENT "Détail" '(1 1 15 1 4 0 1)
	SF-TOGGLE "Conserver les calques ?" FALSE
)

(script-fu-menu-register "script-fu-luminescence-volute-abstract" "<Image>/Filters/abcdugimp.free.fr/Motifs/Luminescence + 2.1/")
;; ---------------------------------------------------------
;; * 		    Script-Fu volute abstraite
;; ----END--------------------------------------------------


;; ---------------------------------------------------------
;; *									     
;; * 		    Script-Fu Entrelacs 
;; *							   		     
;; ---------------------------------------------------------

(define (apply-luminescence-entrelats image
												nom
												repoussage
												couleur
												image-width image-height
												taille-x taille-y turb detail
												mode2 mode1
												conserv)


;; init generale
    (let* (
		(uni2-layer 0)
		(m1 0)
		(m2 0)
		(layer 0)
		
		;; creation des calques
		(uni-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Brouillage uni 1" 100 NORMAL))) ;; 
		(fond-layer (car (gimp-layer-new image image-width image-height RGBA-IMAGE "Fond" 100 NORMAL))) ;;
	)

	;; add layer
	(gimp-image-add-layer image fond-layer -1)
	(gimp-image-add-layer image uni-layer -1)
	
	
;; init calques ;; vider les calques pour qu'il n'y est pas de trace indesirable
(gimp-edit-clear uni-layer)
	


;; --------------------------------------------------
;;			base
;; --------------------------------------------------

(gimp-context-set-foreground couleur)
(gimp-edit-fill fond-layer 0)

;; --------------------------------------------------

(plug-in-solid-noise RUN-NONINTERACTIVE image uni-layer 0 turb 0 detail taille-x taille-y)

(set! uni2-layer (car (gimp-layer-new-from-drawable uni-layer image))) ;; dupliquer
(gimp-image-add-layer image uni2-layer -1)
(gimp-drawable-set-name uni2-layer "Brouillage uni 2")

;; --------------------------------------------------
;; mode de calque

(if (= mode2 0) (set! m2 DIFFERENCE-MODE))
(if (= mode2 1) (set! m2 SUBTRACT-MODE))
(if (= mode2 2) (set! m2 GRAIN-EXTRACT-MODE))
(if (= mode2 3) (set! m2 DIVIDE-MODE))

(if (= mode1 0) (set! m1 DIFFERENCE-MODE))
(if (= mode1 1) (set! m1 SUBTRACT-MODE))
(if (= mode1 2) (set! m1 GRAIN-EXTRACT-MODE))

(gimp-layer-set-mode uni-layer m1)
(gimp-layer-set-mode uni2-layer m2)

;; --------------------------------------------------
;; repoussage
(if (= repoussage TRUE)
	(begin
		(plug-in-emboss RUN-NONINTERACTIVE image uni2-layer 45 90 70 1) ;; repoussage
		(gimp-layer-set-mode uni2-layer DIVIDE-MODE)
		(gimp-layer-set-mode uni-layer VALUE-MODE)
	)
)

;; --------------------------------------------------


(if (= conserv FALSE)
	(begin
		(gimp-image-merge-down image uni-layer EXPAND-AS-NECESSARY)
		(set! layer (car (gimp-image-merge-down image uni2-layer EXPAND-AS-NECESSARY)))
		(gimp-drawable-set-name layer nom)
	)
)

   )
)



(define (script-fu-luminescence-entrelats repoussage
													couleur
													image-width image-height
													taille-x taille-y turb detail
													mode2 mode1
													conserv)

(let* (
	;; conserver les outils dans des variables
	(old-fg (car (gimp-context-get-foreground)))

	;; creation de l'image
	(image (car (gimp-image-new image-width image-height RGB)))
	)
	
	(apply-luminescence-entrelats image
											"Effet entrelacs"
											repoussage
											couleur
											image-width image-height
											taille-x taille-y turb detail
											mode2 mode1
											conserv)


;; mise a jour
	(gimp-display-new image)
	;; remettre toutes les outils comme au debut
	(gimp-context-set-foreground old-fg)

   )
)

;; registre 
(script-fu-register "script-fu-luminescence-entrelats"
		    "Entrelacs"
		    "Génère une texture, effet de lumière : entrelacs."
		    "Michel Douez"
			"abcdugimp.free.fr - creative commons licence"
		    "31/10/2007"
		    ""
	SF-TOGGLE "Repoussage ? (annule les modes de calque)" FALSE
	SF-COLOR "Couleur - Il est conseillé de ne faire
		    varier que la teinte et la saturation" '(33 100 58)
	SF-ADJUSTMENT _"Width" '(256 10 1024 1 100 0 0)
	SF-ADJUSTMENT _"Height" '(256 10 768 1 100 0 0)
	SF-ADJUSTMENT "Taille X" '(8 0.1 16 0.1 1 1 0)
	SF-ADJUSTMENT "Taille Y" '(8 0.1 16 0.1 1 1 0)
	SF-TOGGLE "Turbulent ?" TRUE
	SF-ADJUSTMENT "Détail" '(1 1 15 1 4 0 1)
	SF-OPTION "Mode de calque Brouillage uni 2" '("0 - Différence" "1 - Soustraction" "2 - Extraction de grain" "3 - Diviser")
	SF-OPTION "Mode de calque Brouillage uni 1" '("0 - Différence" "1 - Soustraction" "2 - Extraction de grain")
	SF-TOGGLE "Conserver les calques ?" FALSE
)

(script-fu-menu-register "script-fu-luminescence-entrelats" "<Image>/Filters/abcdugimp.free.fr/Motifs/Luminescence + 2.1/")
;; ---------------------------------------------------------
;; * 		    Script-Fu Entrelacs 
;; ----END--------------------------------------------------

